/*
*******************************************************************************
*
* File:         runtime_ppu.h
* RCS:          $Header: $
* Description:  PPU run-time support 
* Author:       Fabrizio Petrini 
* Created:
* Modified:
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
*******************************************************************************
*/


#ifndef __runtime_ppu__
#define __runtime_ppu__

#ifdef LIBSPE1

#include <libspe.h>

#else /* LIBSPE2 */

#include <libspe2.h>
#include <sync_utils.h>
#include <pthread.h>

#endif /* LIBSPE1 */

/* standard includes */
#include <unistd.h>
#include <sched.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <libsync.h>
#include <sys/time.h>
#include <malloc_align.h>
#include <free_align.h>
#include <inttypes.h>
#include <math.h>
#include <malloc.h>
#include <pthread.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <arpa/inet.h>


/* program dependent includes */
#include "../common.h"
#include "timers.h"
#include "dist.h"


/*
*******************************************************************************
*
*                              externals
*
*******************************************************************************
*/


/* the number of SPUS */
extern unsigned N;

/* the prefix of the distribution files */
extern char dist_prefix[MAX_STRING];

/* computes the ceiling of the base two logarithm of the given value */
extern unsigned int ceiling_log2 ( unsigned int value );

/* write in the mailbox of all SPUs */
extern void write_in_mbox_all( unsigned int val );

/* thread initialization and termination */
void task_init();
void task_end();

/* event monitoring */
void init_dist_table();
void parse_event_buffers();
void print_event_distributions();


#endif /* __runtime_ppu__ */





 
